diff --git a/doc/general.texi b/doc/general.texi
index ed137f999f..65aee47f2a 100644
--- a/doc/general.texi
+++ b/doc/general.texi
@@ -466,6 +466,7 @@ library:
 @item raw NULL                  @tab X @tab
 @item raw video                 @tab X @tab X
 @item raw id RoQ                @tab X @tab
+@item raw SBC                   @tab   @tab X
 @item raw Shorten               @tab   @tab X
 @item raw TAK                   @tab   @tab X
 @item raw TrueHD                @tab X @tab X
diff --git a/libavformat/Makefile b/libavformat/Makefile
index cb70eac920..6270c28a8a 100644
--- a/libavformat/Makefile
+++ b/libavformat/Makefile
@@ -447,6 +447,8 @@ OBJS-$(CONFIG_S337M_DEMUXER)             += s337m.o spdif.o
 OBJS-$(CONFIG_SAMI_DEMUXER)              += samidec.o subtitles.o
 OBJS-$(CONFIG_SAP_DEMUXER)               += sapdec.o
 OBJS-$(CONFIG_SAP_MUXER)                 += sapenc.o
+OBJS-$(CONFIG_SBC_DEMUXER)               += sbcdec.o rawdec.o
+OBJS-$(CONFIG_MSBC_DEMUXER)              += sbcdec.o rawdec.o
 OBJS-$(CONFIG_SBG_DEMUXER)               += sbgdec.o
 OBJS-$(CONFIG_SCC_DEMUXER)               += sccdec.o subtitles.o
 OBJS-$(CONFIG_SCC_MUXER)                 += sccenc.o subtitles.o
diff --git a/libavformat/allformats.c b/libavformat/allformats.c
index 6a9b9883c9..a6b72715bd 100644
--- a/libavformat/allformats.c
+++ b/libavformat/allformats.c
@@ -211,6 +211,7 @@ static void register_all(void)
     REGISTER_MUXDEMUX(MPJPEG,           mpjpeg);
     REGISTER_DEMUXER (MPL2,             mpl2);
     REGISTER_DEMUXER (MPSUB,            mpsub);
+    REGISTER_DEMUXER (MSBC,             msbc);
     REGISTER_DEMUXER (MSF,              msf);
     REGISTER_DEMUXER (MSNWC_TCP,        msnwc_tcp);
     REGISTER_DEMUXER (MTAF,             mtaf);
@@ -277,6 +278,7 @@ static void register_all(void)
     REGISTER_DEMUXER (S337M,            s337m);
     REGISTER_DEMUXER (SAMI,             sami);
     REGISTER_MUXDEMUX(SAP,              sap);
+    REGISTER_DEMUXER (SBC,              sbc);
     REGISTER_DEMUXER (SBG,              sbg);
     REGISTER_MUXDEMUX(SCC,              scc);
     REGISTER_DEMUXER (SDP,              sdp);
diff --git a/libavformat/sbcdec.c b/libavformat/sbcdec.c
new file mode 100644
index 0000000000..a04a7c4328
--- /dev/null
+++ b/libavformat/sbcdec.c
@@ -0,0 +1,47 @@
+/*
+ * RAW SBC demuxer
+ * Copyright (C) 2017  Aurelien Jacobs <aurel@gnuage.org>
+ *
+ * This file is part of FFmpeg.
+ *
+ * FFmpeg is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; either
+ * version 2.1 of the License, or (at your option) any later version.
+ *
+ * FFmpeg is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with FFmpeg; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#include "avformat.h"
+#include "rawdec.h"
+
+#if CONFIG_SBC_DEMUXER
+AVInputFormat ff_sbc_demuxer = {
+    .name           = "sbc",
+    .long_name      = NULL_IF_CONFIG_SMALL("raw SBC (low-complexity subband codec)"),
+    .extensions     = "sbc",
+    .raw_codec_id   = AV_CODEC_ID_SBC,
+    .read_header    = ff_raw_audio_read_header,
+    .read_packet    = ff_raw_read_partial_packet,
+    .flags          = AVFMT_GENERIC_INDEX,
+};
+#endif
+
+#if CONFIG_MSBC_DEMUXER
+AVInputFormat ff_msbc_demuxer = {
+    .name           = "msbc",
+    .long_name      = NULL_IF_CONFIG_SMALL("raw mSBC (wideband speech mono SBC)"),
+    .extensions     = "msbc",
+    .raw_codec_id   = AV_CODEC_ID_MSBC,
+    .read_header    = ff_raw_audio_read_header,
+    .read_packet    = ff_raw_read_partial_packet,
+    .flags          = AVFMT_GENERIC_INDEX,
+};
+#endif
diff --git a/libavformat/utils.c b/libavformat/utils.c
index 84e49208b8..860fbc30c9 100644
--- a/libavformat/utils.c
+++ b/libavformat/utils.c
@@ -336,6 +336,7 @@ static int set_codec_from_probe_data(AVFormatContext *s, AVStream *st,
         { "mjpeg_2000",AV_CODEC_ID_JPEG2000,   AVMEDIA_TYPE_VIDEO },
         { "mp3",       AV_CODEC_ID_MP3,        AVMEDIA_TYPE_AUDIO },
         { "mpegvideo", AV_CODEC_ID_MPEG2VIDEO, AVMEDIA_TYPE_VIDEO },
+        { "sbc",       AV_CODEC_ID_SBC,        AVMEDIA_TYPE_AUDIO },
         { "truehd",    AV_CODEC_ID_TRUEHD,     AVMEDIA_TYPE_AUDIO },
         { 0 }
     };